/*
 * This program will run the stack subprogram and generate
 * a lot of possible stack. 
 *
 * Output:
 *	<number of args>;<numbers of envs>;<args len>;<envs len>;
 *	<prog name len>;<hardware len>;<stack base>;<argv address>
 *
 * Compilation:
 *  + gcc -o stack_ran stack_ran.c
 *
 * THIS PROGRAM IS FOR EDUCATIONAL PURPOSES *ONLY*
 * IT IS PROVIDED "AS IS" AND WITHOUT ANY WARRANTY
 *
 * (c) 2004 Copyright by Inode <inode@wayreth.eu.org>
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>
#include <time.h>
#include <string.h>
#include <sys/systeminfo.h>

#define MAX_ARG 20
#define MAX_ENV 20
#define MAX_LEN 255

#define VULPROG "./stack"

int main( int argc, char ** argv)
{
	int x,l,y,pid;
	int num_arg = 0;
	int num_env = 0;
	int len_arg = 0;
	int len_env = 0;
	char * env[100];
	char * arg[100];
	char * curr;
	char buff[1000];
	char buf[100];
	char platform[256];
 	unsigned long base = (unsigned long) argv[0]; 	

	FILE * out;

	int number = 0;

	if( argc < 3 ) {
		fprintf(stdout, "%s <out file> <number time>\n",argv[0]);
		exit(0);
	}

	number = atoi( argv[2] );

	base = ( base | 0xffff ) & 0xfffffffc;

	srand((unsigned)time(NULL));

	sysinfo(SI_PLATFORM, platform, sizeof(platform));

	for( l = 0; l < number; l++)
	{
		num_arg = (rand()%MAX_ARG) + 2;
		num_env = (rand()%MAX_ENV);

		len_arg = 0;
		len_env = 0;

	        env[ num_env ] = NULL;
       		arg[ num_arg ] = NULL;

		for( x = 0; x < num_arg; x++) 
			if( x == 1 ) {
				len_arg += strlen( argv[1] ) + 1;
				arg[ x ] = argv[1];
			} else {
				y = (rand()%MAX_LEN) +1;
				curr = (char *)malloc(y);
				memset( curr, 'A', y-1);
				curr[y-1]= 0;
				len_arg += strlen(curr) + 1;
				arg[ x ] = curr;
			}

		for( x = 0; x < num_env; x++) {
			y = (rand()%MAX_LEN) +1;
			curr = (char *)malloc(y);
			memset( curr, 'A', y-1);
			curr[y-1]= 0;
			len_env += strlen(curr) + 1;
			env[ x ] = curr;
		}

		memset( buf,0,sizeof(buf));
		memset( buf,'A', rand()%20+1);
		sprintf(buff, "cp %s %s",VULPROG,buf);
		system( buff );

		sprintf(buff, "./%s", buf);

		out = fopen(argv[1],"a");
		fprintf(out ,"\n%d;%d;%d;%d;%d;%d;%p;",num_arg,num_env, len_arg, len_env,strlen( (char *)(strrchr(buff,'/') + 1 )) + 1, strlen( platform ) + 1, (char*)base);
		fclose( out );

		if ((pid=fork()) < 0)
		{
			perror ("Fork failed");
			exit(0);
		}

		if (!pid){
			execve(buff, arg, env);
		}
		else
			waitpid (pid, NULL, 0);

		unlink( buff );

	}
	return 0;
}
